/**
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 * @format
 * @oncall draft_js
 */
'use strict';

var seenKeys = {};
var MULTIPLIER = Math.pow(2, 24);

function generateRandomKey() {
  var key;

  while (key === undefined || seenKeys.hasOwnProperty(key) || !isNaN(+key)) {
    key = Math.floor(Math.random() * MULTIPLIER).toString(32);
  }

  seenKeys[key] = true;
  return key;
}

function clearGenerateRandomKeySeenKeys() {
  Object.getOwnPropertyNames(seenKeys).forEach(function deleteKeys(key) {
    delete seenKeys[key];
  });
}

module.exports = generateRandomKey;
module.exports.clearGenerateRandomKeySeenKeys = clearGenerateRandomKeySeenKeys;